#include <sta/rtos2/signal.hpp>


namespace sta
{
	Rtos2Signal::Rtos2Signal(osSemaphoreId_t * semaphore)
		: semaphore_{semaphore}
	{}

	void Rtos2Signal::notify()
	{
		osSemaphoreRelease(*semaphore_);
	}

	bool Rtos2Signal::peek()
	{
		return (osSemaphoreGetCount(*semaphore_) != 0);
	}

	bool Rtos2Signal::test()
	{
		return (osSemaphoreAcquire(*semaphore_, 0) == osOK);
	}

	void Rtos2Signal::wait()
	{
		osSemaphoreAcquire(*semaphore_, osWaitForever);
	}
} // namespace sta
