#include <sta/rtos2/watchdog.hpp>

#ifdef STA_RTOS2_WATCHDOG_ENABLE

#include <cmsis_os2.h>


// Access handles from freertos.c
extern osTimerId_t STA_RTOS2_WATCHDOG_TIMER_HANDLE;


namespace sta
{
	void startWatchdogTimer()
	{
		osTimerStart(STA_RTOS2_WATCHDOG_TIMER_HANDLE, STA_RTOS2_WATCHDOG_TIMER_PERIOD);
	}
} // namespace sta


// Declare with C linkage
extern "C"
{
	void STA_RTOS2_WATCHDOG_TIMER_CALLBACK(void *)
	{
		// Notify watchdog task to send heartbeat message
		// Required because blocking in a timer callback is not allowed
		sta::notifyWatchdog(STA_WATCHDOG_FLAG_HEARTBEAT);
	}
}


#endif // STA_RTOS2_WATCHDOG_ENABLE
